//
//  bluetoothDetect.swift
//  Runner
//
//  Created by Apirak on 1/11/2566 BE.
//

import Foundation
import UIKit
import CoreBluetooth


class BluethoothDetect : NSObject, CBCentralManagerDelegate, CBPeripheralManagerDelegate {
  
    
    var manager:CBCentralManager!
    var mbBluetoothOn:Bool = false
    private var peripheralManager : CBPeripheralManager!


    func isBluetoothAuthorized() -> Bool {
        if #available(iOS 13.1,   *) {
            switch CBCentralManager.authorization {
            case .allowedAlways: return true
            case .notDetermined: return false
            case .restricted: return false
            case .denied: return false
            @unknown default: return false
            }
        } else if #available(iOS 13.0, *) {
            switch CBCentralManager().authorization {
            case .allowedAlways: return true
            case .notDetermined: return false
            case .restricted: return false
            case .denied: return false
            @unknown default: return false
            }
        }
        //https://stackoverflow.com/questions/57238647/ios-13-how-to-check-if-user-has-accepted-bluetooth-permission
        // Before iOS 13, Bluetooth permissions are not required
        return true
    }
    
    func centralManagerDidUpdateState(_ central: CBCentralManager) {
        switch central.state {
        case .poweredOn:
            mbBluetoothOn = true
            break
        case .poweredOff:
            mbBluetoothOn = false
            break
        case .resetting:
            mbBluetoothOn = false
            break
        case .unauthorized:
            mbBluetoothOn = false
            break
        case .unsupported:
            mbBluetoothOn = false
            break
        case .unknown:
            mbBluetoothOn = false
            break
        default:
            mbBluetoothOn = false
            break
        }
    }
    
    func isBluetoothOn(  )-> Bool {

        return mbBluetoothOn;
    }
    
    required override init() {
        super.init()
        manager          = CBCentralManager()
        manager.delegate = self
        mbBluetoothOn = false;
      
        //monitor bluetooth status to request permission
        let showPermissionAlert = 1
          let options = [CBCentralManagerOptionShowPowerAlertKey: showPermissionAlert]
        peripheralManager = CBPeripheralManager(delegate: self, queue: nil, options:options)
    
    }
  
    func peripheralManagerDidUpdateState(_ peripheral: CBPeripheralManager) {
        var statusMessage = ""

         switch peripheral.state {
         case .poweredOn:
             statusMessage = "Bluetooth Status: Turned On"

         case .poweredOff:
             statusMessage = "Bluetooth Status: Turned Off"

         case .resetting:
             statusMessage = "Bluetooth Status: Resetting"

         case .unauthorized:
             statusMessage = "Bluetooth Status: Not Authorized"
             
         case .unsupported:
             statusMessage = "Bluetooth Status: Not Supported"

         default:
             statusMessage = "Bluetooth Status: Unknown"
         }

     //    print(statusMessage)

         if peripheral.state == .poweredOff {
             //TODO: Update this property in an App Manager class
         }
    }
  
    
}
